/**
 * What the kobold did during enslavement.
 */
function EnslavementShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.beesting = false; // Whether or not the kobold was stung by bees in the forest.
    this.captured = false; // Whether or not the kobold was enslaved.
    this.captureFucked = false; // Whether or not the kobold was fucked during capture.
    this.captureEnjoyed = false; // Whether or not the kobold enjoyed getting fucked during capture.
    
    this.nightOne = new EnslavementNightOneShared(); // First night of enslavement: caravan confinement.
    this.noonTwo = new EnslavementNoonTwoShared(); // Second noon of enslavement: hamlet auction.

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {EnslavementShared-stripped} enslavement A EnslavementShared object, stripped of private members and all functions.
     */
    this.load = function (enslavement) {
        if (!enslavement) {
            that.load(new EnslavementShared());
            return;
        }
        that.beesting = enslavement.beesting || false;
        that.captured = enslavement.captured || false;
        that.captureFucked = enslavement.captureFucked || false;
        that.captureEnjoyed = enslavement.captureEnjoyed || false;
        that.nightOne.load(enslavement.nightOne);
        that.noonTwo.load(enslavement.noonTwo);
    };
}

