/**
 * Hide section of the woods.
 * @param {ForestController} controller The Forest controller.
 */
function ForestWoodsRunFailStruggle(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstChoice = new ForestWoodsRunFailHate(ctrl);
    var secondChoice = new ForestWoodsRunFailEnjoy(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var cunt = ctrl.misc.cunt();
        global.kobold.history.shared.enslavement.captureFucked = true;
        var toReturn = `[p]
                            You smack the wolf's strong forearm, slapping and batting at it with both of your hands.
                            You begin to writhe your body around once more, kicking and failing wildly,
                            yet all of your protests remain unnoticed.
                            The canine simply undoes his pants, his swollen sheath coming into view, the tapered tip of his cock already protruding from it.
                            Panicking, your brain works overtime to think of [i]something[/i], [b]anything[/b] that could save you now, yet it draws a complete blank.
                        [/p]
                        [p]
                            While you continue to struggle and squirm, the lupine gives his emerging length a few strokes, his shaft rapidly growing to its full size.
                            Only after preparing himself to [b]fuck your brains out[/b], does the wolf pay your incessant floundering any mind.
                            He harshly [b]bashes[/b] you against the tree a second time, strong enough to make the entire wooden giant shake,
                            and to knock the resistance out of you.
                            With his prey pacified, the canine lines up his member with your virginal ${cunt ? `slit` : `tailhole`}.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = ctrl.struggle.has() ? "disabled" : "";
        var isSelected = ctrl.struggle.get() === ForestWoodsRunFailStruggleChoice.HATE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Hate it</button>`;

        var tooltip = global.parser.parse(`You'd rather dip your hand into a pile of rusty metal than get fucked by this [b]brute[/b].`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = ctrl.struggle.has() ? "disabled" : "";
        var isSelected = ctrl.struggle.get() === ForestWoodsRunFailStruggleChoice.ENJOY;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Love it</button>`;

        var tooltip = global.parser.parse(`If this [i]is[/i] happning, you might as well enjoy it.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.struggle.set(ForestWoodsRunFailStruggleChoice.HATE);
            loadNextPart(firstChoice);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.struggle.set(ForestWoodsRunFailStruggleChoice.ENJOY);
            loadNextPart(secondChoice);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.runFail.get() !== ForestWoodsRunFailChoice.STRUGGLE) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        part += firstChoice.build();
        part += secondChoice.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.runFail.get() !== ForestWoodsRunFailChoice.STRUGGLE) {
            return;
        }

        firstChoice.registerListeners();
        secondChoice.registerListeners();

        if (ctrl.struggle.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var ForestWoodsRunFailStruggleChoice = {
    HATE: 1,
    ENJOY: 2
};
