/**
 * Proposition section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreePropositionAgree(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = MorningThreePropositionChoice.AGREE;
    var reqController = ctrl.proposition;
    var subController = ctrl.propositionAgree;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new MorningThreePropositionAgreeSelector(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var hers = dick ? `hers` : `his`;
        var toReturn = `[p]
                            Your heart is thumping like crazy.
                            Your hand shivers in ${hers} and your fingers grow sweaty.
                            You hope ${he} doesn't mind.
                            As you eye ${his} alluring frame up and down, you can feel your loins pleasantly stirring.
                            You've [i]rarely[/i] felt this way before.
                            Without a moment's hesitation, you stammer out something remotely affirmative in response to her question.
                            ${Her} grin widens further, and ${he} leads you away from the crowd.
                        [/p]
                        [p]
                            Not that you [i]need[/i] much leading.
                            Wanting this every bit as much as ${he} does, you match ${his} brisk pace, walking alongside your new friend to a spot of privacy.
                            You carelessly bump into some people along the way, too concerned with one another to pay much attention to where you're going,
                            but eventually you manage to reach the alleyway.
                            A place where the sun has yet to reach.
                            It's rather dark, and somewhat cold,
                            but that last part's all but forgotten as your new partner practically [b]jumps[/b] ontop of you the moment you're somewhat out of sight.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.propositionAgree.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
